
{
	These are a couple of the basic Exec routines that you might
	use.  The functions and structures having to do with ports
	and messages are in Ports.i, and everything having to do with
	IO is in ExecIO.i.  Note that you don't have to open the
	exec library.
}

const
	MemPublic = 1;
	MemChip   = 2;
	MemFast   = 4;
	MemClear  = 65536;


Function OpenLibrary(s : string; v : integer): Address;
    forward;
Procedure CloseLibrary(l : Address);
    forward;
Function AvailMem(r : integer): integer;
    forward;
Function AllocMem(s, r : integer): Address;
    forward;
Procedure FreeMem(m : Address; s : integer);
    forward;
Function FindTask(s : String): Address;
    forward;
Function SetTaskPri(t : Address; p : Integer): Integer;
    forward;
Procedure Forbid;
    forward;
Procedure Permit;
    forward;
