{
	These are the things you'll need in order to use Exec messages.
	You will not need to include Exec.i before this.
}

type
    Node = record
	lnSucc : ^Node;
	lnPred : ^Node;
	lnType : Byte;
	lnPri  : Byte;
	lnName : String;
    end;

    MsgPort = record
	mpNode    : Node;
	mpFlags   : Byte;
	mpSigBit  : Byte;
	mpSigTask : Address;
	mpMsgList : Address;
    end;
    MsgPortPtr = ^MsgPort;

    Message = record
	mnNode		: Node;
	mnReplyPort	: MsgPortPtr;
	mnLength	: Short;
    end;
    MessagePtr = ^Message;

Procedure AddPort(p : MsgPortPtr);
    forward;
Function FindPort(n : String): MsgPortPtr;
    forward;
Function GetMsg(p : MsgPortPtr): MessagePtr;
    forward;
Procedure PutMsg(p : MsgPortPtr; m : MessagePtr);
    forward;
Procedure RemPort(m : MsgPortPtr);
    forward;
Procedure ReplyMsg(m : MessagePtr);
    forward;
Function WaitPort(p : MsgPortPtr): MessagePtr;
    forward;
